#version 110
#pragma optimization(off);

varying vec4 pos; // pixels position in normal space
varying vec4 tpos; // position on the depth texture; needs work
varying vec4 rpos; 
varying vec3 normal; 
uniform sampler2D tex;
uniform sampler2D sha;
uniform vec3 lpos;
uniform vec3 cpos;
uniform int lmap;

vec4 Shadow (inout vec4 color)
{
	tpos.xyz = tpos.xyz / tpos.w;
        tpos.xy = (tpos.xy + vec2(1.0)) / 2.0 ;
	
	
	
	vec4 shadow = texture2D(sha,tpos.xy);
	
	pos[3] = 0.0;
	
	float shv = 0.0;
	
	for (int i = 3;i > 0;i--)
	{
	  shv+= shadow[i]*64.0;
	  
	  shv*=64.0;
	}


		
	shv += shadow[0]*64.0;
	
	if (lmap!=0)
	{
		if ( length( pos - vec4(lpos,0.0) +1.0 )  > shv  )
		color-=vec4(0.8,0.8,0.8,0.0);
		else
		color -= ( texture2D(tex,tpos.xy)*0.5 ) ;
	}
	else
	if ( length( pos - vec4(lpos,0.0) +1.0 )  > shv  )
		color/=2.0;

	if ( ( tpos.x>1.0) || (tpos.y>1.0) || ( tpos.x<0.0) || (tpos.y<0.0) )
	{
	color = vec4 (0.0,0.0,0.5,1.0);
	}
	return color;

}

vec4 DiffuseSpecular (inout vec4 color)
{
	vec3 lightDir = normalize( vec3( pos ) - lpos  );
	
	float diffuse = max( dot (  -normal, lightDir ), 0.0 );
	
	vec3 eyeToPixel = vec3( pos ) - cpos;
	eyeToPixel = normalize(eyeToPixel);
	
	vec3 halfVec = - (eyeToPixel+lightDir);
	halfVec = normalize (halfVec);
	
	float spec =0.0;
	if (diffuse > 0.0)
	{
	  spec = max( dot( normal, halfVec ),0.0 );
	  spec = pow(spec,64.0);
	  spec*=0.25;
	}

	return color * diffuse + vec4(1.0,1.0,1.0,1.0)*spec;
}



void main()

{

	vec4 color = texture2D(tex,gl_TexCoord[0].st);
	color = vec4(0.6,0.6,0.6,1.0);
	
	color = DiffuseSpecular(color);
	color = Shadow(color); 
	gl_FragColor =color;
	
	   
	  


}




